Skip to main content
Signature
<ais-menu
  attribute="string"
  // Optional parameters
  :limit="number"
  :show-more="boolean"
  :show-more-limit="number"
  :sort-by="string[] | function"
  :transform-items="function"
  :class-names="object"
/>

Import

To ensure optimal bundle sizes, see Optimize build size.
Vue
import { AisMenu } from "vue-instantsearch";
// Use "vue-instantsearch/vue3/es" for Vue 3

export default {
  components: {
    AisMenu
  },
  // ...
};

See this widget in action

Preview this widget and its behavior.

About this widget

The ais-menu widget displays a menu that lets users choose a single value for a specific attribute.
The ais-menu widget uses a hierarchical refinement internally, so it can’t refine values that include the default separator (>). To support these values, use the ais-hierarchical-menu widget instead.

Requirements

The attribute provided to the widget must be in attributes for faceting, either on the dashboard or using the attributesForFaceting parameter with the API.

Examples

Vue
<ais-menu attribute="categories" />

Props

attribute
string
required
The name of the attribute in the record.To avoid unexpected behavior, you can’t use the same attribute prop in a different type of widget.
Vue
<ais-menu attribute="categories" />
limit
number
default:10
How many facet values to retrieve. When you enable the show-more feature, this is the number of facet values to display before clicking the “Show more” button.
Vue
<ais-menu
  // [...]
  :limit="20"
/>
show-more
boolean
default:false
Whether to display a button that expands the number of items.
Vue
<ais-menu
  // [...]
  show-more
/>
show-more-limit
number
default:20
Amount of items to show if showing more. Requires show-more to be true.
Vue
<ais-menu
  // [...]
  :show-more-limit="30"
/>
sort-by
string[] | function
How to sort refinements. Must be one or more of the following strings:
  • "count" (same as "count:desc")
  • "count:asc"
  • "count:desc"
  • "name" (same as "name:asc")
  • "name:asc"
  • "name:desc"
  • "isRefined" (same as "isRefined:asc")
  • "isRefined:asc"
  • "isRefined:desc"
It’s also possible to give a function, which receives items two by two, like JavaScript’s Array.sort.If facetOrdering is set for this facet in renderingContent, and no value for sortBy is passed to this widget, facetOrdering is used, and the default order as a fallback.
To prevent creating infinite loops, avoid passing arrays, objects, or functions directly in the template. These values aren’t referentially equal on each render, which causes the widget to re-register every time. Instead, define them in your component’s data option and reference them in the template.
Vue
<ais-menu
  // [...]
  :sort-by="['isRefined', 'count:desc']"
/>
transform-items
function
default:"items => items"
A function that receives the list of items before they are displayed. It should return a new array with the same structure. Use this to transform, filter, or reorder the items.The function also has access to the full results data, including all standard response parameters and parameters from the helper, such as disjunctiveFacetsRefinements.
Vue
<template>
  <!-- ... -->
  <ais-menu
    // [...]
    :transform-items="transformItems"
  />
</template>

<script>
export default {
  methods: {
    transformItems(items) {
      return items.map((item) => ({
        ...item,
        label: item.label.toUpperCase(),
      }));
    },

    /* or, combined with results */
    transformItems(items, { results }) {
      return items.map((item) => ({
        ...item,
        label: item.isRefined
          ? `${item.label} (${results.nbPages} pages)`
          : item.label,
      }));
    },
  },
};
</script>
class-names
object
default:"{}"
The CSS classes you can override:
  • .ais-Menu. The root element of the widget.
  • .ais-Menu--noRefinement. The root element of the widget with no refinement.
  • .ais-Menu-list. The list of all menu items.
  • .ais-Menu-item. The menu list item.
  • .ais-Menu-item--selected. The selected menu list item.
  • .ais-Menu-link. The clickable menu element.
  • .ais-Menu-label. The label of each item.
  • .ais-Menu-count. The count of values for each item.
  • .ais-Menu-showMore. The button used to display more categories.
  • .ais-Menu-showMore--disabled. The disabled button used to display more categories.
Vue
<ais-menu
  [...]
  :class-names="{
    'ais-Menu': 'MyCustomMenu',
    'ais-Menu-link': 'MyCustomMenuLink',
    // ...
  }"
/>

Customize the UI

default
The slot to override the complete DOM output of the widget.When you implement this slot, none of the other slots will change the output, as the default slot surrounds them.Scope
  • items: object[]. The values applicable to this menu.
  • canRefine: boolean. Can the refinement be applied?
  • canToggleShowMore: boolean. Is show-more possible?
  • isShowingMore: boolean. Is show-more enabled?
  • refine: (value: string) => void. The function to select a refinement.
  • createURL: (value: string) => string. The function to return a link for this refinement.
  • sendEvent: (eventType: 'click', facetValue: string) => void. The function to send click events.
    • The view event is automatically sent when the facets are rendered.
    • The click event is automatically sent when refine is called.
    • You can learn more about the insights middleware.
Where each item is an object containing:
  • value: string. The value of the menu item.
  • label: string. The human-readable value of the menu item.
  • count: number. The number of results matched after a refinement is applied.
  • isRefined: boolean. Indicates if the refinement is applied.
Vue
<ais-menu attribute="categories">
  <template
    v-slot="{
      items,
      canToggleShowMore,
      isShowingMore,
      toggleShowMore,
      refine,
      createURL,
      sendEvent,
    }"
  >
    <ul>
      <li v-for="item in items" :key="item.value">
        <a
          :href="createURL(item.value)"
          :style="{ fontWeight: item.isRefined ? 'bold': '' }"
          @click.prevent="refine(item.value)"
        >
          {{item.label}} - {{item.count}}
        </a>
      </li>
      <li>
        <button :disabled="!canToggleShowMore" @click="toggleShowMore">
          {{ isShowingMore ? 'Less' : 'More'}}
        </button>
      </li>
    </ul>
  </template>
</ais-menu>
showMoreLabel
The slot to override the DOM output for the label of the “Show more” button.Scope
  • isShowingMore: boolean. Is show-more enabled?
Vue
<ais-menu attribute="categories" show-more>
  <template v-slot:showMoreLabel="{ isShowingMore }">
    {{ isShowingMore ? 'Less' : 'More' }}
  </template>
</ais-menu>

HTML output

HTML
<div class="ais-Menu">
  <ul>
    <li>
      <a class="ais-Menu-link">
        <span class="ais-Menu-label">Apple</span>
        <span class="ais-Menu-count">50</span>
      </a>
    </li>
    <!-- more items -->
  </ul>
  <button class="ais-Menu-showMore">Show more</button>
</div>
If SEO is important for your search page, ensure that your custom HTML is optimized for search engines:
  • Use <a> tags with href attributes to allow search engine bots to follow links.
  • Use semantic HTML and include structured data when relevant.
For more guidance, see the SEO checklist.
Last modified on May 19, 2026

UI libraries / Angular InstantSearch / Widgets
Signature
<ais-menu
  attribute="string"

  // Optional parameters
  [limit]="number"
  [showMore]="boolean"
  [showMoreLimit]="number"
  showMoreLabel="string"
  showLessLabel="string"
  [sortBy]="string[]|function"
  [autoHideContainer]="boolean"
  [transformItems]="function"
></ais-configure>
Import
1
2
3
4
5
6
7
8
import { NgAisMenuModule } from 'angular-instantsearch';

@NgModule({
  imports: [
    NgAisMenuModule,
  ],
})
export class AppModule {}

1. Follow additional steps in Optimize build size to ensure your code is correctly bundled.
2. This imports all the widgets, even the ones you don’t use. Read the Getting started guide for more information.

About this widget

The ais-menu allows a user to select a single value to refine from a list.

Requirements

The attributes passed to the attributes prop must be declared as Attributes for faceting on the Algolia dashboard) or configured as attributesForFaceting with the Algolia API.

Examples

1
<ais-menu attribute="brand"></ais-menu>

Props

attribute
type: string
Required

The name of the attribute in the record.

To avoid unexpected behavior, you can’t use the same attribute prop in a different type of widget.

1
<ais-menu attribute="brand"></ais-menu>
limit
type: number
default: 10
Optional

How many facet values to retrieve. When you enable the showMore feature, this is the number of facet values to display before clicking the “Show more” button.

1
2
3
4
<ais-menu
  // ...
  [limit]="20"
></ais-menu>
showMore
type: boolean
default: false
Optional

Controls the display of the show more button.

1
2
3
4
<ais-menu
  // ...
  [showMore]="true"
></ais-menu>
showMoreLimit
type: number
Optional

Amount of items to show if showing more.

1
2
3
4
5
<ais-menu
  // ...
  [showMore]="true"
  [showMoreLimit]="20"
></ais-menu>
showMoreLabel
type: string
default: Show more
Optional

Label of the “Show more” button.

1
2
3
4
5
<ais-menu
  // ...
  [showMore]="true"
  showMoreLabel="See more"
></ais-menu>
showLessLabel
type: string
default: Show less
Optional

Label of the show less button.

1
2
3
4
5
<ais-menu
  // ...
  [showMore]="true"
  showLessLabel="See less"
></ais-menu>
sortBy
type: string[]|Function
default: ["name:asc"]
Optional

How to sort refinements. Must be one or more of the following strings:

  • "count" (same as "count:desc")
  • "count:asc"
  • "count:desc"
  • "name" (same as "name:asc")
  • "name:asc"
  • "name:desc"
  • "isRefined" (same as "isRefined:asc")
  • "isRefined:asc"
  • "isRefined:desc"

It’s also possible to give a function, which receives items two by two, like JavaScript’s Array.sort.

1
2
3
4
<ais-menu
  // ...
  [sortBy]="['name:desc']"
></ais-menu>
autoHideContainer
type: boolean
Optional

Hides the menu if there’s no item to display.

1
2
3
4
<ais-menu
  // ...
  [autoHideContainer]="true"
></ais-menu>
transformItems
type: function
default: items => items
Optional

Receives the items and is called before displaying them. Should return a new array with the same shape as the original array. Useful for transforming, removing, or reordering items.

In addition, the full results data is available, which includes all regular response parameters, as well as parameters from the helper (for example disjunctiveFacetsRefinements).

1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
26
@Component({
  template: `
    <ais-menu
      // ...
      [transformItems]="transformItems"
    ></ais-menu>
  `,
})
export class AppComponent {
  transformItems(items) {
    return items.map(item => ({
      ...item,
      label: item.label.toUpperCase(),
    }));
  },

  /* or, combined with results */
  transformItems(items, { results }) {
    return items.map(item => ({
      ...item,
      label: item.isRefined
        ? `${item.label} (${results.nbPages} pages)`
        : item.label,
    }));
  },
}

HTML output

1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
<div class="ais-Menu">
  <div class="ais-Menu-searchBox">
    <!-- SearchBox widget here -->
  </div>
  <ul class="ais-Menu-list">
    <li class="ais-Menu-item ais-Menu-item--selected">
      <a class="ais-Menu-link" href="#">
        <span class="ais-Menu-label">Appliances</span>
        <span class="ais-Menu-count">4,306</span>
      </a>
    </li>
    <li class="ais-Menu-item">
      <a class="ais-Menu-link" href="#">
        <span class="ais-Menu-label">Audio</span>
        <span class="ais-Menu-count">1,570</span>
      </a>
    </li>
  </ul>
  <button class="ais-Menu-showMore">Show more</button>
</div>

Customize the UI with connectMenu

If you want to create your own UI of the ais-menu widget, you can combine the connectMenu connector with the TypedBaseWidget class.

This connector is also used to build other widgets: MenuSelect

1. Extend the TypedBaseWidget class

First of all, you will need to write some boilerplate code to initialize correctly the TypedBaseWidget class. This happens in the constructor() of your class extending the TypedBaseWidget class.

1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
import { Component, Inject, forwardRef, Optional } from '@angular/core';
import { TypedBaseWidget, NgAisInstantSearch, NgAisIndex } from 'angular-instantsearch';

@Component({
  selector: 'app-menu',
  template: '<p>It works!</p>'
})
export class Menu extends TypedBaseWidget {
  constructor(
    @Inject(forwardRef(() => NgAisIndex))
    @Optional()
    public parentIndex: NgAisIndex,
    @Inject(forwardRef(() => NgAisInstantSearch))
    public instantSearchInstance: NgAisInstantSearch
  ) {
    super('Menu');
  }
}

There are a couple of things happening in this boilerplate:

  • create a Menu class extending TypedBaseWidget
  • reference the <ais-instantsearch> parent component instance on the Menu widget class
  • set app-menu as a selector, so we can use our component as <app-menu></app-menu>

2. Connect your custom widget

The TypedBaseWidget class has a method called createWidget() which takes two arguments: the connector to use and an object of options (instance options) for this connector. We call this method at ngOnInit. This component now implements OnInit.

1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
26
27
28
29
30
31
import { Component, Inject, forwardRef, Optional } from '@angular/core';
import { TypedBaseWidget, NgAisInstantSearch, NgAisIndex } from 'angular-instantsearch';

import connectMenu, {
  MenuWidgetDescription,
  MenuConnectorParams
} from 'instantsearch.js/es/connectors/menu/connectMenu';

@Component({
  selector: 'app-menu',
  template: '<p>It works!</p>'
})
export class Menu extends TypedBaseWidget<MenuWidgetDescription, MenuConnectorParams> {
  public state: MenuWidgetDescription['renderState']; // Rendering options
  constructor(
    @Inject(forwardRef(() => NgAisIndex))
    @Optional()
    public parentIndex: NgAisIndex,
    @Inject(forwardRef(() => NgAisInstantSearch))
    public instantSearchInstance: NgAisInstantSearch
  ) {
    super('Menu');
  }
  ngOnInit() {
    this.createWidget(connectMenu, {
      // instance options
      attribute: 'brand',
    });
    super.ngOnInit();
  }
}

3. Render from the state

Your component instance has access to a this.state property which holds the rendering options of the widget.

public state: MenuWidgetDescription['renderState'];
// {
//   items: object[];
//   refine: Function;
//   createURL: Function;
//   isShowingMore: boolean;
//   canToggleShowMore: boolean;
//   toggleShowMore: Function;
//   widgetParams: object;
// }
1
2
3
4
5
6
7
8
9
10
11
<select
  class="menu-select"
  (change)="state.refine($event.target.value)"
>
  <option
    *ngFor="let item of state.items"
    [value]="item.value"
    [selected]="item.isRefined">
    {{ item.label }}
  </option>
</select>

If SEO is critical to your search page, your custom HTML markup needs to be parsable:

  • use plain <a> tags with href attributes for search engines bots to follow them,
  • use semantic markup with structured data when relevant, and test it.

Refer to our SEO checklist for building SEO-ready search experiences.

Rendering options

items
type: object[]

The elements that can be refined for the current search results. With each item:

  • value: string: the value of the menu item
  • label: string: the label of the menu item
  • count: number: the number of results matched after a refinement is applied
  • isRefined: boolean: whether the refinement is applied
refine
type: function

Toggles a refinement.

createURL
type: function
default: (item.value) => string

Generates a URL for the corresponding search state.

isShowingMore
type: boolean

Whether the menu is displaying all the menu items.

canToggleShowMore
type: boolean

Whether the “Show more” button can be activated (enough items to display more and not already displaying more than the limit).

toggleShowMore
type: function

Toggles the number of displayed values between limit and showMoreLimit.

widgetParams
type: object

All original widget options forwarded to the render function.

Instance options

attribute
type: string
Required

The name of the attribute for faceting.

To avoid unexpected behavior, you can’t use the same attribute prop in a different type of widget.

limit
type: number
default: 10
Optional

How many facet values to retrieve. When you enable the

showMoreLimit
type: number
default: 10
Optional

How many facet values to retrieve when showing more.

sortBy
type: string[]|function
default: ["isRefined", "name:asc"]
Optional

How to sort refinements. Must be one or more of the following strings:

  • "count:asc"
  • "count:desc"
  • "name:asc"
  • "name:desc"
  • "isRefined"

It’s also possible to give a function, which receives items two by two, like JavaScript’s Array.sort.

transformItems
type: function
Optional

Receives the items and is called before displaying them. Should return a new array with the same shape as the original array. Useful for transforming, removing, or reordering items.

In addition, the full results data is available, which includes all regular response parameters, as well as parameters from the helper (for example disjunctiveFacetsRefinements).

Full example

1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
26
27
28
29
30
31
32
33
34
35
36
37
38
39
40
41
42
43
import { Component, Inject, forwardRef, Optional } from '@angular/core';
import { TypedBaseWidget, NgAisInstantSearch, NgAisIndex } from 'angular-instantsearch';

import connectMenu, {
  MenuWidgetDescription,
  MenuConnectorParams
} from 'instantsearch.js/es/connectors/menu/connectMenu';

@Component({
  selector: 'app-menu',
  template: `
<select
  class="menu-select"
  (change)="state.refine($event.target.value)"
>
  <option
    *ngFor="let item of state.items"
    [value]="item.value"
    [selected]="item.isRefined">
    {{ item.label }}
  </option>
</select>
`
})
export class Menu extends TypedBaseWidget<MenuWidgetDescription, MenuConnectorParams> {
  public state: MenuWidgetDescription['renderState']; // Rendering options
  constructor(
    @Inject(forwardRef(() => NgAisIndex))
    @Optional()
    public parentIndex: NgAisIndex,
    @Inject(forwardRef(() => NgAisInstantSearch))
    public instantSearchInstance: NgAisInstantSearch
  ) {
    super('Menu');
  }
  ngOnInit() {
    this.createWidget(connectMenu, {
      // instance options
      attribute: 'brand',
    });
    super.ngOnInit();
  }
}
Did you find this page helpful?